clear all
clc

%const;
const;

alfa1=p*u*cp/kef;
beta1=-dh*k0/kef;
alfa2=k0/Def;
beta2=u/Def;
x=linspace(0,L,n+1);
dx=mean(diff(x));
Tg=zeros(n+1,1)+T0;

while err>1e-6 && ii<imax

    for i=1:2*n

        if i==1
            A(i,i)=-2;
            A(i,i+1)=1-alfa1*dx/2;
            A(i,i+n)=beta1*exp(-E/(R*Tg(i+1,1)))*(dx)^2;
           c(i,1)=-(1+alfa1*dx/2)*T0;
        elseif i>1 && i<n
            A(i,i)=-2;
            A(i,i+1)=1-alfa1*dx/2;
            A(i,i-1)=1+alfa1*dx/2;
            A(i,i+n)=beta1*exp(-E/(R*Tg(i+1,1)))*(dx)^2;
           c(i,1)=0;

        elseif i==n
            A(i,i)=-3;
            A(i,i-1)=4;
            A(i,i-2)=-1;
           c(i,1)=0;

        elseif i==n+1
            A(i,i)=-(2+alfa2*exp(-E/(R*Tg(i+1-n,1)))*(dx)^2);
            A(i,i+1)=1-beta2*dx/2;
           c(i,1)=-(1+beta2*dx/2)*C0;
        elseif i>n+1 && i<2*n
            A(i,i)=-(2+alfa2*exp(-E/(R*Tg(i+1-n,1)))*(dx)^2);
            A(i,i+1)=1-beta2*dx/2;
            A(i,i-1)=1+beta2*dx/2; 
           c(i,1)=0; 

        elseif i==2*n
            A(i,i)=-3;
            A(i,i-1)=4;
            A(i,i-2)=-1;
           c(i,1)=0;
       end    
    end
    
    B=A;
    B(:,end+1)=c;
    BB=rref(B);
    y=BB(:,end);

    T=[T0(1);y(1:n)];
    C=[C0(1);y(n+1:2*n)];

    err=sum(abs(Tg-T)./T);

    Tg=T;
    ii=ii+1;
end

subplot(2,1,1)
plot(x/L,(T-273.15)-(T0-273.15))
xlabel('x/L')
ylabel('T-T0')

subplot(2,1,2)
plot(x/L,C/C0)
xlabel('x/L')
ylabel('C/C0')
