function res=gj_elim(A,C)

n=sum(size(A))/2;
A(:,end+1)=C;

% Raw Displacement for Remiving Zero from Diagonal 
for i=1:n
    if abs(A(i,i))<eps        
       for k=i+1:n           
            if abs(A(k,i) )>eps
                B=A(i,:);
                A(i,:)=A(k,:);
                A(k,:)=B;
            end
       end
    end    
end

% Zeroing for Downer Triangle 
for j=1:n-1
     for i=1+j:n
         if abs(A(i,j))>eps
            A(i,:)=A(i,:)-A(j,:)*A(i,j)/A(j,j);
         end
     end
end
 
% Zeroing for Upper Triangle 
 for j=1:n-1
     for i=n-j:-1:1         
         if abs(A(i,n+1-j))>eps
            A(i,:)=A(i,:)-A(n+1-j,:)*A(i,n+1-j)/A(n+1-j,n+1-j);
         end
     end
 end
 
 % Zeroing for Numerical Residue 
for i=1:n
    A(i,:)=A(i,:)/A(i,i);
    for j=1:n+1
        if abs(A(i,j))<1e-10
            A(i,j)=0;
        end
    end
end
 
res=A(:,end);