clear all
clc

% Constants
const;

A=(1-2*alfa*dy/((dx)*dx^2));
if A<0    
    for i=1:2000 
        ny=ny+1;
        dy=L/(ny);
        A=(1-2*alfa*dy/((dx)*dx^2));
        if A>0
          break
        end
    end   
end

% Creating Initial Vectors
x=linspace(0,delta,nx+1);
y=linspace(0,L,ny+1);
CA=zeros(nx+1,ny+1);
CA(:,1)=CA0;
CA(1,:)=CAi;
CA(nx,:)=CA0;

% Calculating Coefficients
for i=1:nx
    a1(i)=(alfa*dy/(x(i)*dx^2));
    a2(i)=(1-2*alfa*dy/(x(i)*dx^2));
    a3(i)=(alfa*dy/(x(i)*dx^2));    
end

% Solver
for j=1:ny
    for i=2:nx-1
        CA(i,j+1)=(a1(i)*CA(i+1,j)+a2(i)*CA(i,j)+a3(i)*CA(i-1,j));
    end
end

% Plotting Results
[X,Y]=meshgrid(x,y);
mesh(X,Y,CA')
xlabel('x')
ylabel('y')
zlabel('CA')
