% Constants in SI Unit

F0=0.1; % m^3/s
Vmin=2; % m^3
Ro=1000; % kg/m^3
c=4200; % J/kg.K
CA0=1; % mol/m^3
CB0=2; % mol/m^3
Tj0=25+273.15; % K
Fj=0.001; % m^3/s
Vj=0.001; % m^3
Roj=1000; % kg/m^3
cj=4200; % J/kg.K
n=1;
m=2;
k=1; % (m^3/mol)^(n+m-1).s^-1
E=10000; % J/mol
dH=-1e8; % J/mol
U=1000; % W/m^2.K
Ah=1; % m^2
Kv=0.1; % 1/s
dt=0.1; % s
err=0;
tf=100; % s
Tol=1e-8;
R=8.314; % J/mol.K
