clear all
clc

% Input Constants
const;  

dz=(zn-zo)/(n-1);
for i=1:n
    z(i)=zo+i*dz;
end

teta_g=ones(n,1);

A = zeros(n,n);
B = zeros(n,1);

for counter = 1:1000

    for i = 1:n

      if i==1
        A(i,i)=-(2+(fi*dz)^2*teta_g(i)^(1/3));
        A(i,i+1)=1;
        B(i,1)=-1;
      elseif i>1 && i<n
        A(i,i)= -(2+(fi*dz)^2*teta_g(i)^(1/3));
        A(i,i+1)=1;
        A(i,i-1)=1;
        B(i,1)=0;
      elseif i==n
          A(i,i)=(3+2*(fi)^2*dz*teta_g(i)^(1/3));
        A(i,i-1) = -4;
        A(i,i-2) = 1;
        B(i,1)=0;
      end
    end

    teta=inv(A)*B;
    err = mse(teta_g-teta);

 
    if err<Tol
        break
    elseif err>Tol
        teta_g=teta;
    end
end

% Plotting Result
 plot(z,teta,'linewidth',2)
 xlabel('z')
 ylabel('\theta')
 axis([0 1 0 1])
 